#ifndef MODEL_H_
#define MODEL_H_
#include "chain.h"
#include "data.h"
#include "parameters.h"

typedef struct {
	chain *c;	
	int tempering;
	parameters param;
	data dat;
	void (*gibbsfuncs[6])(chain *);
	int (*metrofuncs[6])(chain *,long *);
	char metlabel[6][10];
	int ngibbs,nmets;
	long **success,**attempt;

} model;

int choose_gibbsmets(model *m);
void destroy_model(model *m);
void printallrates(FILE *OUT,model *m);
void starting_chains(model *m);

#endif
