#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "prior.h"
#include "myio.h"
#include "naiveutil.h"
#include "nrutil.h"
#include "random.h"

int replicates;

int main(int argc, char *argv[])
{
	int i;
	model m;
	sample s;
	FILE *out;

	if (argc != 4) {
		printf("use \nnaive infile outfile seed\n\n");
		exit(0);
	}
	
	m=read_model(argv[1]);
	out=openoutputfile(argv[2]);
	starTup(atoi(argv[3]));

	if (replicates<0) {  /* use for a simulated dataset  of size -replicates */
		m.n=-replicates;
		s=generate_sample(&m);
		write_imatrix(openoutputfile("gendat"),s.x,1,m.n,1,2*m.loci);
		printf("%d fathers %d mothers\n\n",s.fathers.n,s.mothers.n);
		destroy_sample(&s,m.n);
		return 1;
	}

	for (i=1;i<=replicates;) {
		s=generate_sample(&m);
		if (matches(&m,&s)) {
			i++;
			fprintf(out,"%d %d\n",s.fathers.n,s.mothers.n);
			if (i%20==0) {	
				printf(".");
				if (i%1000==0)
					printf("\n");
				fflush(stdout);
			}
		}
		destroy_sample(&s,m.n);
	}
	fclose(out);
	return 1;
}