#ifndef NAIVEUTIL_H_
#define NAIVEUTIL_H_
#include "prior.h"

typedef struct  {
	int n;
	int *parentage;
	int **genotype;
}parents;

typedef struct   {
	parents fathers,mothers;
	int **x;
} sample;

typedef struct  {
	prior fatherprior,motherprior,alphaprior,betaprior;
	int **data,n,loci,*alleles,freqmodel,moffmodel,foffmodel;
	double **rho;
} model;

typedef struct {
	int **data,n,loci,*alleles,freqmodel,*mother;
	double **rho;
} crypt_model;

model read_model(char *filename);
crypt_model read_crypt_model(char *filename);
sample generate_sample(model *m);
void destroy_sample( sample *s, int n);
int matches(model *m, sample *s);

int *generate_genotype(int loci, int *alleles, double **rho, int freqmodel);
int possible_father(int *father, int *mother, crypt_model *m);
#endif