#ifndef PRIOR_H_
#define PRIOR_H_
#include <stdio.h>
enum Distribution  
{
		NULLPRIOR=-2,
		CONSTPRIOR=-1,
		UNIFORM=0,
		GAMMA=1,
		LOGNORMAL=2,
		NORMAL=3,
		DIRICHLET=4,
		POISSON=5,
		GEOMETRIC=6
};

typedef struct priortype {
    int prtype;
    double par[2];
} prior;

typedef struct priorvaltype {
	prior p;
	double x;
} prior_val;

typedef struct priorvalstype {
	prior *p;
	double *x;
	int nx,*which;
} prior_vals;

prior prior_scan(FILE *in, char *name, prior default_val);
prior *priors_scan(FILE *in, char *name, prior default_val, int *len);
void sample_prior(double *x,prior a);
prior readprior(FILE *in);
prior *readpriors(FILE *in, int *n);
double log_prior(double *x, prior a);
void testprior(double *x, double *y, prior a, int len);
void copyprior(prior *to, prior from);
void printprior(FILE *out,prior a,char *end);


prior readpriorval(FILE *in,double *val);
int isconst(prior *p);
int isnull(prior_val *p);
int iscorrectconst(prior_val *p);
void correctconst(prior_val *p);
double log_priorval(prior_val *p);
void sample_prior_val(prior_val *p);
prior_val priorval_scan(FILE *in, char *name);
prior_vals priorvals_scan(FILE *in, char *name);
double	samplenewlogscale(prior_val *p,double tune,double *old);
double	samplenewlogscaleprior(prior p,double *x, double tune);
prior_vals readpriorvals(FILE *in);
double log_priorvals(prior_vals *p);
void printpriorvals(FILE *out, char *message, prior_vals *a);
void printpriorval(FILE *out, char *message, prior_val *a);
void printpriortype(FILE *out,char *message,prior a,double val);
prior_val copyprior_val(prior_val *p);
#endif
